/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.render;

import org.lwjgl.opengl.GL11;
import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.objects.te.TEBellows;

import static net.dries007.tfc.api.util.TFCConstants.MOD_ID;

@SideOnly(Side.CLIENT)
public class TESRBellows extends TESRBase<TEBellows>
{
    private static final ResourceLocation TEXTURE = new ResourceLocation(MOD_ID + ":textures/blocks/devices/bellows_tesr.png");

    @Override
    public void func_192841_a(TEBellows te, double x, double y, double z, float partialTicks, int destroyStage, float alpha)
    {
        GlStateManager.func_179094_E();
        GlStateManager.func_179137_b(x + 0.5D, y + 0.03125D, z + 0.5D);
        GlStateManager.func_179114_b((te.func_145832_p() & 3) * 90f, 0.0F, 1.0F, 0.0F);
        GlStateManager.func_179121_F();

        try
        {
            GlStateManager.func_179094_E();
            GlStateManager.func_179131_c(1, 1, 1, 1);
            this.func_147499_a(TEXTURE);
            GlStateManager.func_179140_f();

            GlStateManager.func_179137_b(x + 0.5d, y, z + 0.5d);
            GL11.glRotatef(180.0F - 90.0F * te.func_145832_p(), 0.0F, 1.0F, 0.0F);
            GlStateManager.func_179137_b(-0.5d, 0.0d, -0.5d);

            Tessellator t = Tessellator.func_178181_a();
            BufferBuilder b = t.func_178180_c();

            // TODO: make this render less of a clusterfuck
            double tileY = 1 - te.getHeight() + 0.075; // todo: replace 0.5 with the total distance outwards

            b.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181707_g);
            drawMiddle(b, tileY);
            drawTop(b, tileY);
            t.func_78381_a();
        }
        finally
        {
            GlStateManager.func_179121_F();
        }
    }

    @Override
    public boolean func_188185_a(TEBellows te)
    {
        return false;
    }

    private void drawMiddle(BufferBuilder b, double y)
    {
        double[][] sides = getVerticesBySide(0.125, 0.875, y, 0.875, 0.125, 0.125, "xy");

        for (double[] v : sides)
        {
            b.func_181662_b(v[0], v[1], v[2]).func_187315_a(v[3] * 0.5, v[4] * 0.5).func_181675_d();
        }
    }

    private void drawTop(BufferBuilder b, double y)
    {
        double[][] sides = getVerticesBySide(0, 1, 0.125 + y, 1, 0, y, "xy");
        double[][] tops = getVerticesBySide(0, 1, 0.125 + y, 1, 0, y, "z");

        for (double[] v : sides)
        {
            b.func_181662_b(v[0], v[1], v[2]).func_187315_a(v[3] * 0.0625 + 0.5, v[4] * 0.5 + 0.5).func_181675_d();
        }
        for (double[] v : tops)
        {
            b.func_181662_b(v[0], v[1], v[2]).func_187315_a(v[3] * 0.5, v[4] * 0.5 + 0.5).func_181675_d();
        }
    }
}
