/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.world.classic.worldgen;

import java.util.Random;
import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.block.state.IBlockState;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenerator;
import net.minecraftforge.common.IPlantable;

@ParametersAreNonnullByDefault
public class WorldGenTallPlant extends WorldGenerator
{
    private IPlantable plant;

    public WorldGenTallPlant(IPlantable plant)
    {
        this.plant = plant;
    }

    public boolean func_180709_b(World world, Random rng, BlockPos start)
    {
        for (int i = 0; i < 20; ++i)
        {
            BlockPos spot = start.func_177982_a(rng.nextInt(4) - rng.nextInt(4), -1, rng.nextInt(4) - rng.nextInt(4));
            BlockPos prevSpot = spot;
            IBlockState prevState = world.func_180495_p(spot);
            final int n = 2 + rng.nextInt(rng.nextInt(3) + 1);
            for (int y = 0; y < n; y++)
            {
                spot = spot.func_177982_a(0, +1, 0);
                IBlockState toPlant = plant.getPlant(world, spot);
                if (!world.func_175623_d(spot) || !prevState.func_177230_c().canSustainPlant(prevState, world, prevSpot, EnumFacing.UP, plant) ||
                    !plant.getPlant(world, spot).func_177230_c().func_176196_c(world, spot))
                    break;
                func_175903_a(world, spot, toPlant);
                prevState = toPlant;
                prevSpot = spot;
            }
        }

        return true;
    }
}
